Merge tag 'vfs-5.17-fixes-2' of git://git.kernel.org/pub/scm/fs/xfs/xfs-linux
[linux-block.git] / scripts / link-vmlinux.sh
CommitLineData
1f2bfbd0 1#!/bin/sh
b2441318 2# SPDX-License-Identifier: GPL-2.0
1f2bfbd0
SR
3#
4# link vmlinux
5#
d151e971
MY
6# vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_OBJS) and
7# $(KBUILD_VMLINUX_LIBS). Most are built-in.a files from top-level directories
8# in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
9# $(KBUILD_VMLINUX_LIBS) are archives which are linked conditionally
10# (not within --whole-archive), and do not require symbol indexes added.
1f2bfbd0
SR
11#
12# vmlinux
13# ^
14# |
d151e971
MY
15# +--< $(KBUILD_VMLINUX_OBJS)
16# | +--< init/built-in.a drivers/built-in.a mm/built-in.a + more
1f2bfbd0 17# |
3a166fc2
NP
18# +--< $(KBUILD_VMLINUX_LIBS)
19# | +--< lib/lib.a + more
20# |
1f2bfbd0
SR
21# +-< ${kallsymso} (see description in KALLSYMS section)
22#
23# vmlinux version (uname -v) cannot be updated during normal
24# descending-into-subdirs phase since we do not yet know if we need to
25# update vmlinux.
26# Therefore this step is delayed until just before final link of vmlinux.
27#
28# System.map is generated to document addresses of all kernel symbols
29
30# Error out on error
31set -e
32
3ec8a5b3
MY
33LD="$1"
34KBUILD_LDFLAGS="$2"
35LDFLAGS_vmlinux="$3"
36
7d153696
MY
37is_enabled() {
38 grep -q "^$1=y" include/config/auto.conf
39}
40
1f2bfbd0
SR
41# Nice output in kbuild format
42# Will be supressed by "make -s"
43info()
44{
c39013ee 45 printf " %-7s %s\n" "${1}" "${2}"
1f2bfbd0
SR
46}
47
a8cccdd9
ST
48# Generate a linker script to ensure correct ordering of initcalls.
49gen_initcalls()
50{
51 info GEN .tmp_initcalls.lds
52
53 ${PYTHON} ${srctree}/scripts/jobserver-exec \
54 ${PERL} ${srctree}/scripts/generate_initcall_order.pl \
55 ${KBUILD_VMLINUX_OBJS} ${KBUILD_VMLINUX_LIBS} \
56 > .tmp_initcalls.lds
57}
58
38e89184
ST
59# If CONFIG_LTO_CLANG is selected, collect generated symbol versions into
60# .tmp_symversions.lds
61gen_symversions()
62{
63 info GEN .tmp_symversions.lds
64 rm -f .tmp_symversions.lds
65
66 for o in ${KBUILD_VMLINUX_OBJS} ${KBUILD_VMLINUX_LIBS}; do
67 if [ -f ${o}.symversions ]; then
68 cat ${o}.symversions >> .tmp_symversions.lds
69 fi
70 done
71}
72
1f2bfbd0
SR
73# Link of vmlinux.o used for section mismatch analysis
74# ${1} output file
75modpost_link()
76{
a5967db9 77 local objects
38e89184 78 local lds=""
a5967db9 79
6358d6e8 80 objects="--whole-archive \
d151e971 81 ${KBUILD_VMLINUX_OBJS} \
6358d6e8
NP
82 --no-whole-archive \
83 --start-group \
84 ${KBUILD_VMLINUX_LIBS} \
85 --end-group"
86
7d153696 87 if is_enabled CONFIG_LTO_CLANG; then
a8cccdd9
ST
88 gen_initcalls
89 lds="-T .tmp_initcalls.lds"
90
7d153696 91 if is_enabled CONFIG_MODVERSIONS; then
38e89184
ST
92 gen_symversions
93 lds="${lds} -T .tmp_symversions.lds"
94 fi
95
dc5723b0
ST
96 # This might take a while, so indicate that we're doing
97 # an LTO link
98 info LTO ${1}
99 else
100 info LD ${1}
101 fi
102
38e89184 103 ${LD} ${KBUILD_LDFLAGS} -r -o ${1} ${lds} ${objects}
1f2bfbd0
SR
104}
105
6804c1af
PZ
106objtool_link()
107{
b1a1a1a0 108 local objtoolcmd;
6804c1af
PZ
109 local objtoolopt;
110
7d153696 111 if is_enabled CONFIG_LTO_CLANG && is_enabled CONFIG_STACK_VALIDATION; then
b1a1a1a0
ST
112 # Don't perform vmlinux validation unless explicitly requested,
113 # but run objtool on vmlinux.o now that we have an object file.
7d153696 114 if is_enabled CONFIG_UNWINDER_ORC; then
b1a1a1a0
ST
115 objtoolcmd="orc generate"
116 fi
117
118 objtoolopt="${objtoolopt} --duplicate"
119
7d153696 120 if is_enabled CONFIG_FTRACE_MCOUNT_USE_OBJTOOL; then
b1a1a1a0
ST
121 objtoolopt="${objtoolopt} --mcount"
122 fi
123 fi
124
7d153696 125 if is_enabled CONFIG_VMLINUX_VALIDATION; then
b1a1a1a0
ST
126 objtoolopt="${objtoolopt} --noinstr"
127 fi
128
129 if [ -n "${objtoolopt}" ]; then
130 if [ -z "${objtoolcmd}" ]; then
131 objtoolcmd="check"
132 fi
133 objtoolopt="${objtoolopt} --vmlinux"
7d153696 134 if ! is_enabled CONFIG_FRAME_POINTER; then
6804c1af
PZ
135 objtoolopt="${objtoolopt} --no-fp"
136 fi
7d153696 137 if is_enabled CONFIG_GCOV_KERNEL || is_enabled CONFIG_LTO_CLANG; then
6804c1af
PZ
138 objtoolopt="${objtoolopt} --no-unreachable"
139 fi
7d153696 140 if is_enabled CONFIG_RETPOLINE; then
6804c1af
PZ
141 objtoolopt="${objtoolopt} --retpoline"
142 fi
7d153696 143 if is_enabled CONFIG_X86_SMAP; then
6804c1af
PZ
144 objtoolopt="${objtoolopt} --uaccess"
145 fi
fd6f57bf 146 if is_enabled CONFIG_SLS; then
e463a09a
PZ
147 objtoolopt="${objtoolopt} --sls"
148 fi
6804c1af 149 info OBJTOOL ${1}
b1a1a1a0 150 tools/objtool/objtool ${objtoolcmd} ${objtoolopt} ${1}
6804c1af
PZ
151 fi
152}
153
1f2bfbd0 154# Link of vmlinux
341dfcf8 155# ${1} - output file
618916a4 156# ${2}, ${3}, ... - optional extra .o files
1f2bfbd0
SR
157vmlinux_link()
158{
618916a4 159 local output=${1}
8f130512
MY
160 local objs
161 local libs
5df77ad6
MY
162 local ld
163 local ldflags
164 local ldlibs
1f2bfbd0 165
d7b0827f
LT
166 info LD ${output}
167
618916a4
AN
168 # skip output file argument
169 shift
170
7d153696 171 if is_enabled CONFIG_LTO_CLANG; then
8f130512
MY
172 # Use vmlinux.o instead of performing the slow LTO link again.
173 objs=vmlinux.o
174 libs=
175 else
176 objs="${KBUILD_VMLINUX_OBJS}"
177 libs="${KBUILD_VMLINUX_LIBS}"
178 fi
179
5df77ad6
MY
180 if [ "${SRCARCH}" = "um" ]; then
181 wl=-Wl,
182 ld="${CC}"
183 ldflags="${CFLAGS_vmlinux}"
184 ldlibs="-lutil -lrt -lpthread"
185 else
186 wl=
187 ld="${LD}"
188 ldflags="${KBUILD_LDFLAGS} ${LDFLAGS_vmlinux}"
189 ldlibs=
190 fi
191
192 ldflags="${ldflags} ${wl}--script=${objtree}/${KBUILD_LDS}"
193
af73d78b
KC
194 # The kallsyms linking does not need debug symbols included.
195 if [ "$output" != "${output#.tmp_vmlinux.kallsyms}" ] ; then
5df77ad6 196 ldflags="${ldflags} ${wl}--strip-debug"
af73d78b
KC
197 fi
198
7d153696 199 if is_enabled CONFIG_VMLINUX_MAP; then
5df77ad6 200 ldflags="${ldflags} ${wl}-Map=${output}.map"
5cc12472
RV
201 fi
202
5df77ad6
MY
203 ${ld} ${ldflags} -o ${output} \
204 ${wl}--whole-archive ${objs} ${wl}--no-whole-archive \
205 ${wl}--start-group ${libs} ${wl}--end-group \
206 $@ ${ldlibs}
1f2bfbd0
SR
207}
208
e83b9f55 209# generate .BTF typeinfo from DWARF debuginfo
341dfcf8
AN
210# ${1} - vmlinux image
211# ${2} - file to dump raw BTF data into
e83b9f55
AN
212gen_btf()
213{
341dfcf8 214 local pahole_ver
e83b9f55 215
581b31c3 216 if ! [ -x "$(command -v ${PAHOLE})" ]; then
2a67a6cc 217 echo >&2 "BTF: ${1}: pahole (${PAHOLE}) is not available"
341dfcf8 218 return 1
581b31c3
AN
219 fi
220
e83b9f55 221 pahole_ver=$(${PAHOLE} --version | sed -E 's/v([0-9]+)\.([0-9]+)/\1\2/')
21a85bd6
LB
222 if [ "${pahole_ver}" -lt "116" ]; then
223 echo >&2 "BTF: ${1}: pahole version $(${PAHOLE} --version) is too old, need at least v1.16"
341dfcf8 224 return 1
e83b9f55
AN
225 fi
226
341dfcf8 227 vmlinux_link ${1}
af73d78b
KC
228
229 info "BTF" ${2}
9741e07e 230 LLVM_OBJCOPY="${OBJCOPY}" ${PAHOLE} -J ${PAHOLE_FLAGS} ${1}
341dfcf8 231
90ceddcb
FS
232 # Create ${2} which contains just .BTF section but no symbols. Add
233 # SHF_ALLOC because .BTF will be part of the vmlinux image. --strip-all
234 # deletes all symbols including __start_BTF and __stop_BTF, which will
235 # be redefined in the linker script. Add 2>/dev/null to suppress GNU
236 # objcopy warnings: "empty loadable segment detected at ..."
237 ${OBJCOPY} --only-section=.BTF --set-section-flags .BTF=alloc,readonly \
238 --strip-all ${1} ${2} 2>/dev/null
239 # Change e_type to ET_REL so that it can be used to link final vmlinux.
240 # Unlike GNU ld, lld does not allow an ET_EXEC input.
241 printf '\1' | dd of=${2} conv=notrunc bs=1 seek=16 status=none
e83b9f55 242}
1f2bfbd0 243
08beb669 244# Create ${2} .S file with all symbols from the ${1} object file
1f2bfbd0
SR
245kallsyms()
246{
1f2bfbd0
SR
247 local kallsymopt;
248
7d153696 249 if is_enabled CONFIG_KALLSYMS_ALL; then
6895f97e 250 kallsymopt="${kallsymopt} --all-symbols"
1f2bfbd0
SR
251 fi
252
7d153696 253 if is_enabled CONFIG_KALLSYMS_ABSOLUTE_PERCPU; then
c6bda7c9
RR
254 kallsymopt="${kallsymopt} --absolute-percpu"
255 fi
256
7d153696 257 if is_enabled CONFIG_KALLSYMS_BASE_RELATIVE; then
2213e9a6
AB
258 kallsymopt="${kallsymopt} --base-relative"
259 fi
260
08beb669
MY
261 info KSYMS ${2}
262 ${NM} -n ${1} | scripts/kallsyms ${kallsymopt} > ${2}
1f2bfbd0
SR
263}
264
8959e392
KC
265# Perform one step in kallsyms generation, including temporary linking of
266# vmlinux.
267kallsyms_step()
268{
269 kallsymso_prev=${kallsymso}
af73d78b
KC
270 kallsyms_vmlinux=.tmp_vmlinux.kallsyms${1}
271 kallsymso=${kallsyms_vmlinux}.o
08beb669 272 kallsyms_S=${kallsyms_vmlinux}.S
8959e392 273
d7b0827f 274 vmlinux_link ${kallsyms_vmlinux} "${kallsymso_prev}" ${btf_vmlinux_bin_o}
08beb669
MY
275 kallsyms ${kallsyms_vmlinux} ${kallsyms_S}
276
277 info AS ${kallsyms_S}
278 ${CC} ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS} \
279 ${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
280 -c -o ${kallsymso} ${kallsyms_S}
8959e392
KC
281}
282
1f2bfbd0
SR
283# Create map file with all symbols from ${1}
284# See mksymap for additional details
285mksysmap()
286{
287 ${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
288}
289
10916706 290sorttable()
1347a2ce 291{
10916706 292 ${objtree}/scripts/sorttable ${1}
1347a2ce
LT
293}
294
1f2bfbd0 295# Delete output files in case of error
1f2bfbd0
SR
296cleanup()
297{
341dfcf8 298 rm -f .btf.*
1f2bfbd0 299 rm -f .tmp_System.map
a8cccdd9 300 rm -f .tmp_initcalls.lds
38e89184 301 rm -f .tmp_symversions.lds
1f2bfbd0
SR
302 rm -f .tmp_vmlinux*
303 rm -f System.map
304 rm -f vmlinux
5cc12472 305 rm -f vmlinux.map
1f2bfbd0 306 rm -f vmlinux.o
0b956e20 307 rm -f .vmlinux.d
1f2bfbd0
SR
308}
309
1f2bfbd0
SR
310# Use "make V=1" to debug this script
311case "${KBUILD_VERBOSE}" in
312*1*)
313 set -x
314 ;;
315esac
316
317if [ "$1" = "clean" ]; then
318 cleanup
319 exit 0
320fi
321
1f2bfbd0
SR
322# Update version
323info GEN .version
278ae604
MY
324if [ -r .version ]; then
325 VERSION=$(expr 0$(cat .version) + 1)
326 echo $VERSION > .version
1f2bfbd0 327else
278ae604
MY
328 rm -f .version
329 echo 1 > .version
1f2bfbd0
SR
330fi;
331
332# final build of init/
083bc0e1 333${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init need-builtin=1
1f2bfbd0 334
abac4c89 335#link vmlinux.o
abac4c89 336modpost_link vmlinux.o
6804c1af 337objtool_link vmlinux.o
abac4c89
NP
338
339# modpost vmlinux.o to check for section mismatches
a721588d 340${MAKE} -f "${srctree}/scripts/Makefile.modpost" MODPOST_VMLINUX=1
abac4c89 341
898490c0
AG
342info MODINFO modules.builtin.modinfo
343${OBJCOPY} -j .modinfo -O binary vmlinux.o modules.builtin.modinfo
8b41fc44
MY
344info GEN modules.builtin
345# The second line aids cases where multiple modules share the same object.
346tr '\0' '\n' < modules.builtin.modinfo | sed -n 's/^[[:alnum:]:_]*\.file=//p' |
347 tr ' ' '\n' | uniq | sed -e 's:^:kernel/:' -e 's/$/.ko/' > modules.builtin
898490c0 348
7fd78568 349btf_vmlinux_bin_o=""
7d153696 350if is_enabled CONFIG_DEBUG_INFO_BTF; then
af73d78b
KC
351 btf_vmlinux_bin_o=.btf.vmlinux.bin.o
352 if ! gen_btf .tmp_vmlinux.btf $btf_vmlinux_bin_o ; then
da5fb182
SF
353 echo >&2 "Failed to generate BTF for vmlinux"
354 echo >&2 "Try to disable CONFIG_DEBUG_INFO_BTF"
355 exit 1
341dfcf8
AN
356 fi
357fi
358
1f2bfbd0 359kallsymso=""
8959e392 360kallsymso_prev=""
1f2bfbd0 361kallsyms_vmlinux=""
7d153696 362if is_enabled CONFIG_KALLSYMS; then
1f2bfbd0
SR
363
364 # kallsyms support
365 # Generate section listing all symbols and add it into vmlinux
366 # It's a three step process:
2216cf68 367 # 1) Link .tmp_vmlinux.kallsyms1 so it has all symbols and sections,
1f2bfbd0
SR
368 # but __kallsyms is empty.
369 # Running kallsyms on that gives us .tmp_kallsyms1.o with
370 # the right size
2216cf68 371 # 2) Link .tmp_vmlinux.kallsyms2 so it now has a __kallsyms section of
1f2bfbd0
SR
372 # the right size, but due to the added section, some
373 # addresses have shifted.
2216cf68 374 # From here, we generate a correct .tmp_vmlinux.kallsyms2.o
7e2b37c9
NP
375 # 3) That link may have expanded the kernel image enough that
376 # more linker branch stubs / trampolines had to be added, which
377 # introduces new names, which further expands kallsyms. Do another
378 # pass if that is the case. In theory it's possible this results
379 # in even more stubs, but unlikely.
380 # KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
381 # other bugs.
382 # 4) The correct ${kallsymso} is linked into the final vmlinux.
1f2bfbd0
SR
383 #
384 # a) Verify that the System.map from vmlinux matches the map from
385 # ${kallsymso}.
386
8959e392
KC
387 kallsyms_step 1
388 kallsyms_step 2
1f2bfbd0 389
7e2b37c9 390 # step 3
8959e392
KC
391 size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso_prev})
392 size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso})
7e2b37c9
NP
393
394 if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
8959e392 395 kallsyms_step 3
1f2bfbd0
SR
396 fi
397fi
398
d7b0827f 399vmlinux_link vmlinux "${kallsymso}" ${btf_vmlinux_bin_o}
e83b9f55 400
c9a0f3b8 401# fill in BTF IDs
7d153696 402if is_enabled CONFIG_DEBUG_INFO_BTF && is_enabled CONFIG_BPF; then
017dab34
JO
403 info BTFIDS vmlinux
404 ${RESOLVE_BTFIDS} vmlinux
c9a0f3b8
JO
405fi
406
72b3942a
YL
407info SYSMAP System.map
408mksysmap vmlinux System.map
409
7d153696 410if is_enabled CONFIG_BUILDTIME_TABLE_SORT; then
10916706 411 info SORTTAB vmlinux
f14bf6a3
SZ
412 if ! sorttable vmlinux; then
413 echo >&2 Failed to sort kernel tables
414 exit 1
415 fi
1347a2ce
LT
416fi
417
1f2bfbd0 418# step a (see comment above)
7d153696 419if is_enabled CONFIG_KALLSYMS; then
1f2bfbd0
SR
420 mksysmap ${kallsyms_vmlinux} .tmp_System.map
421
422 if ! cmp -s System.map .tmp_System.map; then
5369f550 423 echo >&2 Inconsistent kallsyms data
367e43c5 424 echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
1f2bfbd0
SR
425 exit 1
426 fi
427fi
0b956e20
RV
428
429# For fixdep
430echo "vmlinux: $0" > .vmlinux.d